﻿class Atomo extends MovieClip{
	// criando variáveis
	var velocidade: Number;
	private var xInicial: Number;
	private var xFinal: Number;
	private var yInicial: Number;
	private var yFinal: Number;
	private var deslocamentoX: Number;
	private var deslocamentoY: Number;	
	private var deslocamentoMaximo: Number;
	private var escala: Number;
	private var retaDeDirecao: MovieClip;
	
	public function Inicia(esc: Number, deslocMaximo: Number, 
						   xIni: Number, yIni: Number, xFin: Number, yFin: Number){
		this.escala = esc;
		this.deslocamentoMaximo = deslocMaximo;
		this.xInicial = xIni;
		this.xFinal = xFin;
		this.yInicial = yIni;
		this.yFinal = yFin;
		
		novoMovimento();
	}
	
	public function novoMovimento(){
		this._xscale = escala;
		this._yscale = escala;
		this._x = xInicial + random(xFinal - xInicial - this._width);
		this._y = yInicial + random(yFinal - yInicial - this._height);
		if ((this._x - this._width) < xInicial)
			this._x += this._width;
		if ((this._y - this._height) < yInicial)
			this._y += this._height;
			
		novoDeslocamento(random(deslocamentoMaximo) + 1, random(deslocamentoMaximo) + 1);
	}
	
	public function novoDeslocamento(deslocX: Number, deslocY: Number){
		var angulo: Number;
		
		this.deslocamentoX = deslocX;
		this.deslocamentoY = deslocY;
		
		angulo = Math.atan(-deslocY/deslocX) * 180/Math.PI;
		this.retaDeDirecao._rotation = angulo;		
	}
		
		
	function CalculaAnguloRotacao(outroAtomo: MovieClip) {
		var anguloColisao: Number;                  // angulo formado pelos centros dos atomos
		var anguloTangente: Number;					// angulo tangente a colisao
		var anguloDeslocamento: Number;
		var anguloAnterior: Number;
		var anguloRotacao: Number;
		var sinal: Number = 1;
		var sinalX: Number = 1;
		var sinalY: Number = 1;
		
		anguloColisao = Math.atan((outroAtomo._y - this._y)/(this._x - outroAtomo._x)) * 180/Math.PI;
		anguloTangente = anguloColisao + 90;		
		anguloDeslocamento = Math.atan(-this._y/this._x) * 180/Math.PI;
		
	
		if (anguloColisao >= 90) {
			anguloColisao -= 90;
			if ( (this.deslocamentoX * this.deslocamentoY) < 0 )
				sinal = -1;
		}
		else {
			if ( (this.deslocamentoX * this.deslocamentoY) > 0 )
				sinal = -1;			
		}
		
		anguloAnterior = this._rotation;
		anguloRotacao = 2*sinal*(anguloDeslocamento - anguloColisao);
		
		this.retaDeDirecao._rotation += anguloRotacao;
		
		if ((this.retaDeDirecao._rotation >= 90) && (this.retaDeDirecao._rotation <= 180))
			sinalX = -1;		
		else if ((this.retaDeDirecao._rotation <= 0) && (this.retaDeDirecao._rotation >= -90))
			sinalY = sinalX = -1;
		else if ((this.retaDeDirecao._rotation <= -90) && (this.retaDeDirecao._rotation >= -180))
			sinalY = -1;
		
		novoDeslocamento(this.retaDeDirecao._width * sinalX, this.retaDeDirecao._height * sinalY);
		
	}
	
	function onEnterFrame(){
		var outroAtomo: MovieClip;
		var fator: Number= 1;
		
		outroAtomo = existeColisao();
		
		if (outroAtomo) {
			CalculaAnguloRotacao(outroAtomo);
			fator = 1.5;
		}

		if ( ( (this._x - this._width + this.deslocamentoX) < xInicial ) || 
			 ( (this._x + this._width + this.deslocamentoX) > xFinal))
			this.deslocamentoX = -this.deslocamentoX;

		if ( ( (this._y - this._height + this.deslocamentoY) < yInicial) || 
			 ( (this._y + this._height + this.deslocamentoY) > yFinal))
			this.deslocamentoY = -this.deslocamentoY;
		
		this._x += fator*deslocamentoX;
		this._y += fator*deslocamentoY;

	}
	
	public function associaRetaDeDirecao(reta: MovieClip){
		this.retaDeDirecao = reta;
	}

	function existeColisao(): MovieClip  {
		var i: Number = 0;
		var distancia: Number;
		var existe: Boolean = false;
		var outroAtomo: MovieClip;
			
		do {
			i++;
			outroAtomo = _root["atomo"+i];			
			
			if ( (outroAtomo != undefined) && (this._name != outroAtomo._name) ) {					
				distancia = Math.sqrt(Math.pow(outroAtomo._x - this._x, 2) + Math.pow(outroAtomo._y - this._y, 2));
				if ( distancia < this._width )
					existe = true;				
			}			
		} while ( (outroAtomo != undefined) && (not existe) );

		return outroAtomo;
	}
	
}